Subject: Re: bug#14030: 24.3; expand-file-name expands remote file name on Windows incorrectly

From: Eli Zaretskii <[email-masked]>
Date: Mon, 25 Mar 2013 22:32:52 +0200

> From: Stefan Monnier <[email-masked]>
> Cc: Michael Albinus <[email-masked]>,  [email-masked],  [email-masked]
> Date: Mon, 25 Mar 2013 14:49:49 -0400
> 
> >> Sorry, but I think this is a grave bug.
> > Agreed, but it might be in the byte-compiler rather than in Tramp.
> > At least, nowhere does Tramp seem to request that
> > tramp-drop-volume-letter be inlined, so the call should stay in.
> 
> I think I know what's going on:
> The byte-compiler now optimizes aliases to a function in the same way as
> that function (so if you alias `my-add' to `+', (my-add 5 6) can be
> optimized to 11 as well).
> 
> So your alias to `identity' is optimized just like `identity', IOW it's
> compiled away.

Can the optimizer be taught not to optimize like that if the condition
includes one of a list of known symbols?  Then we could maintain a
list of platform-dependent symbols whose optimization could lead to
platform-dependent .elc files.